/*
 * "Voice" support for ltmodem
 *
 * Actually, as long as we don't want to use onboard DSP,
 * this is going to be used not only for voice but for
 * _everything_.
 *
 * Copyright 1999 Pavel Machek, distribute under GPL
 */

#include "control.h"
#include "dsp.c"
#include "modem_globals.h"

int dp_spk_volume = 0x8ab8;

void
dp_download_fdsp(void)
{
  dp_modem_command(0x13, 0, 0);
  printf( "Size of wDspFdsp is %x, should be %x\n", sizeof(wDspFdsp), 0xcb9*2);
  dp_download_dsp(wDspFdsp, 0xcb9);
}

void
dp_init_fdsp(void)
{
  dp_write_dsp_ram(0x86, 0);
  dp_write_dsp_ram(0x880, 0x9a54);
  dp_write_dsp_ram(0x86c, 0x20);
  dp_write_dsp_ram(0x86e, 0xfff8);
}

void
dp_mute_fdsp(int arg)
{
  printf( "dp_mute_fdsp: %d\n", arg );
  if (arg != 0)
    dp_write_dsp_ram(0x885, dp_spk_volume /* ??? 0x6821c */);
  else
    dp_write_dsp_ram(0x885, 0);
}

void
dp_stop_fdsp(void)
{
  dp_modem_command(0x13, 0, 0);
  x_output(0x18);
  dp_modem_command(0x27, 1, 0);
  dp_set_mercury_gain();
  //  if (something)
  //   dp_stop_fdsp();
  //	else v8bis_init();
}

void
dp_fdsp_record_start(void)
{
  // movb $0x01,0x67d32
  dp_write_dsp_ram(0x871, dp_read_dsp_ram(0x871) | 0x02);
}

/* Strange, dp_start_spkphone is always called with 0 as argument ? */

void
dp_start_spkphone(int arg)
{
  // dp_change_mercury_gain(...);
  dp_write_dsp_ram(0x86, 0);
  dp_modem_command(0x13, 0, 0);
  dp_download_fdsp();
#if 0	/* It seems to hangup. I do not want to hangup! */
  printf( "X_output: 0x07\n" );
  x_output(0x07);
  printf( "X_output: 0x17\n" );
  x_output(0x17);
#endif
  dp_write_dsp_ram(0x800, 0x1c);
  if (arg) {
    //    dp_apollo_command(....);
    //    dp_init_hdsp();
    die( "must not happen\n" );
  } else {
    //    dp_apollo_command(....);
    dp_init_fdsp();
  }
  printf( "Write volume\n" );
  dp_write_dsp_ram(0x885, dp_spk_volume );
  dp_write_dsp_ram(0x724, 0x400);
  printf( "Done\n" );
}

void
dp_init_hdsp(void)
{
  dp_write_dsp_ram(0x8e6, 0x21);
  dp_write_dsp_ram(0x86e, 0xfffd);
  dp_write_dsp_ram(0x87b, 0x8100);
  dp_write_dsp_ram(0x87e, 0x800);
  dp_write_dsp_ram(0x724, 0x400);
  dp_write_dsp_ram(0x87f, 0x1000);
  dp_write_dsp_ram(0x723, 0x08);
  dp_write_dsp_ram(0x880, 0x4000);
  dp_write_dsp_ram(0x747, 0x14);
  dp_write_dsp_ram(0x86c, 0x20);
  //  if (byte_68255)
    dp_write_dsp_ram(0x710, 0x4000);
}

void
dp_start_hdsp(void)
{
  dp_start_spkphone(0);
  dp_write_dsp_ram(0x85, 0x905);
  dp_write_dsp_ram(0x85, 0x9205);
  // dp_set_speakerphone_gain();
  dp_write_dsp_ram(0x725, 0xb6a);
}

void
dp_switch_fdsp(void)
{
  dp_write_dsp_ram(0x97, 0);
  dp_init_fdsp();
  dp_write_dsp_ram(0x85, 0x9f05);
  dp_write_dsp_ram(0x871, 0xc004);
  //  dp_set_speakerphone_gain();
  if (0x67d32 != 1)
    dp_fdsp_record_start();
}

/*
 * Ouch, speakerphone is _not_ what is interesting for us.
 * TAD mode (telephone answering device) IS!
 */

void
dp_download_tad(void)
{
  dp_download_dsp(wDspTad, 0x949);
  dp_modem_command(0x13, 0, 0);
}

void
dp_detect_dtmf(void)
{
  /* This is actually pretty long function */
  dp_write_dsp_ram(0x37, 0x50 /* dp_set_threshold() */ );
  //  dp_set_iirs();
  dp_write_dsp_ram(0x27, 0);
  dp_write_dsp_ram(0x28, 0);
  dp_write_dsp_ram(0x26, 0x1e);
  if (0) {
    dp_write_dsp_ram(0x26, 0x2f);
  }
  if (0) {
    //dp_write_dsp_array(0x1c, 0x15e28, 0xa);
    /* ... */
  } else {
    //dp_write_dsp_array(0x1c, 0x15e40, 0xa);
    dp_write_dsp_ram(0x24, 0x2a49);
    dp_write_dsp_ram(0xfc0, 0x28d5);
  }
  dp_modem_command(8, 0x0b, 0);
  /* ... = */ x_current_time();
              x_current_time();
              x_current_time();
  /* ... */
}

int x68200 = 0x0a, x681da = 0, x68229 = 0x81, x67d69 = 0,
  x67d5d, x67d5c, x67d60, x6822a = 1 /* hmm, setting to 1 basically crashes modem*/, x681bc, x68310, x682a6, x67da2;


void
dp_start_tad(int arg)
{
  int var_18 = 0, var_10 = 0, var_30 = 0;
  int vsm;	/* Sampling mode, as set by AT+VSM */
  int al, cl, save_cl;

  if (x681da == 1)
    dp_init_modem();
  dp_modem_command(0x13, 0, 0);
  x67d69 = arg;
  x_sleep(0x32);
  if (0 == x681bc) {
    x_output(0x07);	/* Basically hangup */
    dp_modem_command(0x13, 0, 0);
    dp_download_tad();
    x67d5d = 0;
    x_output(0x17);
  }
  x67d5c = 0;
  x67d60 = 1;
  al = x67d69;

  if (0 == x68310 && al) {	/* Hmm, if I do if (0), I basically crash the modem */
    dp_write_dsp_ram(0x3d, 0x200);
    dp_regwrite(0xb6, 0xff);
    dp_regread(0xb0);
    dp_regread(0xb0);
    al = x67d69;
  }
  /* 38aa0: */
  /* ecx = sampling mode, from 68229. 0x84 == ADPCM, confirmed now.
     0x81 is 16-bit linear, which should be closest to native.
     ecx -= 0x80 */

  vsm = x68229;
  vsm -= 0x80;
  if (!vsm)
    goto L8aca;
  vsm --;
  vsm --;
  if (!vsm)
    goto L8ac3;
  vsm --;
  if (vsm)
    goto L8acf;
  var_18 |= 0x04;
  goto L8acf;
 L8ac3:
  var_18 |= 0x09;
  goto L8acf;
 L8aca:
  var_18 |= 0x0e;
 L8acf:
  cl = x6822a;
  if (cl!=1)
    goto L8ae1;
  var_10 = 0x04;
  goto L8aef;
 L8ae1:
  save_cl = cl; 
  //  die( "Sorry, I dunno what setne does\n" );
  if (cl != 0x02)
    cl = 0xff;
  else 
    cl = 0;
  //setne(cl);
  cl--;
  cl &= 0x08;
  var_10 = cl;
 L8aef:
  if ((al == 0xc0) ||
      (al == 0xe0) ||
      (al == 0x40) ||
      (al == 0x80))
    dp_write_dsp_ram(0x85, 0x1305);
  else
    dp_write_dsp_ram(0x85, 0x1005);
  al = x67d69;
  if (al & 0x80) {
    if ((al == 0xa0) || (al == 0xf0))
      dp_write_dsp_ram(0x873, 0x4000);
    else
      dp_write_dsp_ram(0x873, 0x8000);
    dp_write_dsp_ram(0x87c, 0x3000);
  }
  dp_write_dsp_ram(0x873, 0);

  cl = x682a6;
  dp_apollo_command(0x20, 0xe0 /* var_30 or arg? */, 0, 
		    7, cl-=3 /* some homologation parameter */, 
		    0, 0, var_10 );
  // dp_set_tad_speaker_gain();
  // dp_set_tad_mic_gain();
  dp_detect_dtmf();
  dp_write_dsp_ram(0x3c, 0x28);
  al = x67d69;
  if ((al == 0xc0) ||
      (al == 0xe0) ||
      (al == 0x40) ||
      (0x80 == al)) {
    dp_write_dsp_ram(0x85, 0x105);
    dp_write_dsp_ram(0x85, 0x1305);
  }
  else 
    dp_write_dsp_ram(0x85, 0x1005);
  /* bc2: */
  al = x67d69;
  if (!(al & 0x80))
    goto bed;

  if ((al == 0xa0) || (al == 0xf0))
    /* bda */
    dp_write_dsp_ram(0x873, 0x4000);
  else
    dp_write_dsp_ram(0x873, 0x8000);
  dp_write_dsp_ram(0x87c, 0x3000);
  /* bf0 */
  goto bf5;

 bed:
  dp_write_dsp_ram(0x87e, 0);
 bf5:
  dp_write_dsp_ram(0xe4, 0x80);
  dp_write_dsp_ram(0xe5, 0xfff0);
  x67da2 = 0;
  x681bc = 1;
}

void
dp_synth_ring_freq1(void)
{
  printf( "FAKE: I just selected one set of values\n" );
  dp_write_dsp_ram(0x5, 0x24b5);
  dp_write_dsp_ram(0x6, 0x346c);
}

void
dp_synth_ring_freq2(void)
{
  printf( "FAKE: I just selected one set of values\n" );
  dp_write_dsp_ram(0x5, 0x2d41);
  dp_write_dsp_ram(0x6, 0x2d41);
}

void
dp_enable_ring_int(void)
{
  dp_regwrite(0xd8, 0xff);
  dp_bamil_rd7 &= 0xf1;
  dp_regwrite(0xd7, dp_bamil_rd7);
}

void
dp_synth_ring_init(void)
{
  dp_write_dsp_ram(0x11, 6+x68200);
  dp_modem_command(0x13, 0, 0);
  dp_download_tad();
  dp_write_dsp_ram(0x85, 0);
  dp_apollo_command(0x20, 0x20, 0, 0, 0, 0, 0, 0x40);
  x_output(0x17);
  dp_modem_command(0x7, 0x1, 0);
  dp_write_dsp_ram(0x17, 0xbb8);
  dp_synth_ring_freq1();
  dp_write_dsp_ram(0x85, 0x20);
  x_output(0x17);
  dp_enable_ring_int();
}

void
dp_synth_ring_on(void)
{
  dp_write_dsp_ram(0x11, x68200);
  sleep(1);
  dp_synth_ring_freq2();
}

void
dp_synth_ring_off(void)
{
  dp_write_dsp_ram(0x85, 0);
  dp_modem_command(0x13, 0, 0);
  x_output(0x18);
}
